var frameSize = { width:0, height:0 };
var contentSize = { width:0, height:0 };


function TEScroller( container, frame, scrollbar, scrollthumb ) {
    if ( container && frame && scrollbar && scrollthumb ) {
        DEBUG( 'initializing scroller' );
    } else {
        throw new Exception( "cannot instanciate TEScroller with null or undefined object" );
    }
    this.frame         = frame;
    this.container     = container; // frame tag
    this.content = null;
    this.frameSize     = { width:0, height:0 };
    this.contentSize   = { width:0, height:0};
    this.contentTop    = 0;

    this.changeContent = _TEScroller__changeContent;
    this.resizeContent = _TEScroller__resizeContent;
    this.toString      = _TEScroller__toString;
    this.setVisible    = _TEScroller__setVisible;
    this.setView       = _TEScroller__setView;
    this.clickToMove   = _TEScroller__clickToMove;
    this.moveThumbBy   = _TEScroller__moveThumbBy;
    this.scrollBar = scrollbar;
    this.thumb     = scrollthumb;
    this.visibility = false;
    this.minThumbHeight = 32;

    this.changeContent( null );
    //this.scrollBar.style.display = 'none';

    if ( this.content ) {
        DEBUG( this.toString() );
    } else {
        DEBUG( "NULL content" );
    }
}

function _TEScroller__setVisible( flag ) {
    if ( flag ) {
        if ( this.visibility == false ) {
            this.scrollBar.style.display = 'block';
            this.thumb.style.display = 'block';
            this.visibility = true;
        }
    } else {
        if ( this.visibility == true ) {
            this.visibility = false;
            this.scrollBar.style.display = 'none';
            this.thumb.style.display = 'none';
        }
    }
}

function _TEScroller__setView( position ) {
    if ( position == undefined ) {
        position = this.contentTop;
    }
    DEBUG( 'setView ' + position );
    var rpos = position;
    if ( position <= - this.contentSize.height + this.frameSize.height ) {
        position = - this.contentSize.height + this.frameSize.height;
    }
    if ( position > 0 ) position = 0;

    this.contentTop = position;
    this.content.style.top = position + 'px';
    DEBUG( 'position ' + rpos + ' ' + position );
    if ( this.visibility == false ) return; // size not available
    var pratio = - parseFloat( position ) / this.contentSize.height;

    var bstyle = document.defaultView.getComputedStyle( this.scrollBar );
    var height_scrollbar = parseInt( bstyle.getPropertyValue( 'height' ) );
    this.thumb.style.top = parseInt( height_scrollbar * pratio ) + 'px';
    return;
}

// add a event listener to inline frame every after content loaded in it.
//
function _TEScroller__changeContent( event ) {
    // set frame size
    var fstyle = document.defaultView.getComputedStyle( this.container );
    this.content = this.container.contentWindow.addEventListener( 'mousewheel', mouseWheel, true );
    this.content = this.container.contentWindow.document.getElementById( "Layer" );

    this.resizeContent( event );
    this.setView( 0 );

    // dirty hacking : send repaint method after 1/4 seconds to adjust window size
    setTimeout( function() { scroller.resizeContent(); scroller.setView(); DEBUG( "REFRESHED" );}, 250 );

}

// receive resize event
function _TEScroller__resizeContent( event ) {
    if ( this.container && this.content ) {
        // get frame size
        var fstyle = document.defaultView.getComputedStyle( this.frame );//container );
        this.frameSize.width  = parseInt( fstyle.getPropertyValue( 'width' ) );
        this.frameSize.height = parseInt( fstyle.getPropertyValue( 'height' ) );
        
        // get content size
        var cstyle = document.defaultView.getComputedStyle( this.content );
        this.contentSize.width  = parseInt( cstyle.getPropertyValue( 'width' ) );
        this.contentSize.height = parseInt( cstyle.getPropertyValue( 'height' ) );

        // window size is larger than contents size
        if ( this.contentSize.height <= this.frameSize.height ) {
            this.setView( 0 );
            this.setVisible( false );
            return;
        }

        // adjust scroll thumb
        if ( this.visibility == false ) { // cannot get scrollbar size
            this.setVisible( true );
            return;
        } 

        var ratio = this.frameSize.height / this.contentSize.height;
        var bstyle = document.defaultView.getComputedStyle( this.scrollBar );
        var height_scrollbar = parseInt( bstyle.getPropertyValue( 'height' ) );
        var height_thumb = parseInt( ratio * height_scrollbar );
        if ( height_thumb < this.minThumbHeight ) {
            height_thumb = this.minThumbHeight;
        }
        this.thumb.style.height = height_thumb + 'px';
        DEBUG( 'THUMB ' + ratio + ' ' + height_scrollbar + ' ' + height_thumb );

        this.setView( this.contentTop );
    }
}

function _TEScroller__toString() {
    return "{ " + this.frameSize.width + ", " + this.frameSize.height + " } - { " 
        + this.contentSize.width + ", " + this.contentSize.height + " }";
}

function _TEScroller__clickToMove( event ) {
    if ( this.visibility == false ) {
        return;
    }

    var bstyle = document.defaultView.getComputedStyle( this.scrollBar );
    var tstyle = document.defaultView.getComputedStyle( this.thumb );
    var top = parseInt( bstyle.getPropertyValue( "top" ) );
    var theight = parseInt( tstyle.getPropertyValue( 'height' ) );
    var bheight = parseInt( bstyle.getPropertyValue( 'height' ) );
    var offset = event.y - top - theight / 2;
    var ratio = parseFloat( offset ) / bheight;
    var pos = parseInt( this.contentSize.height * ratio );
    this.setView( - pos );

    return;
}

function _TEScroller__moveThumbBy( pixel ) {

    var bstyle = document.defaultView.getComputedStyle( this.scrollBar );
    var bheight = parseInt( bstyle.getPropertyValue( 'height' ) );
    var ratio = pixel / bheight;
    this.setView( parseInt( this.contentTop - ratio * this.contentSize.height ) );
}

function thumbMouseDown( event ) {
    DEBUG( 'thumb' );
    lastPos = { x:event.x, y:event.y };
    window.addEventListener( 'mousemove', thumbMouseMove, true );
    window.addEventListener( 'mouseup', thumbMouseUp, true );
    event.stopPropagation();
    event.preventDefault();
}

function thumbMouseMove( event ) {
    var dy = event.y - lastPos.y;
    DEBUG( event.x + ' ' + event.y + ' ' + dy );
    lastPos.y = event.y;
    scroller.moveThumbBy( dy );
    event.stopPropagation();
    event.preventDefault();
}

function thumbMouseUp( event ) {
    DEBUG( 'up' );
    window.removeEventListener( 'mousemove', thumbMouseMove, true );
    window.removeEventListener( 'mouseup', thumbMouseUp, true );
}

function thumbMouseExit( event ) {
    DEBUG( 'exit' );
}


function trackMouseDown( event ) {
    scroller.clickToMove( event );
}

