#!/usr/bin/python
# -*- coding:utf-8 -*-

from dom import *
import scorecard
import makelogo

def newInstance():
    return MLB_yahoo_2005()

class MLB_yahoo_2005 ( scorecard.ScoreCard ):
    def __init__( self ):
        scorecard.ScoreCard.__init__( self )
        self.date = None
        self.games = []
        return
        
    def getName( self ):
        return "MLB (yahoo.com)"

    def getVersion( self ):
        return "1.0"

    def getSportsCategory( self ):
        return "baseball"

    def getCountry( self ):
        return "USA"

    def getURL( self ):
        return "http://sports.yahoo.com/mlb/"#scoreboard/"

    def getStartKeyword( self ):
        return 'id="today_scoreboard"'

    def getEndKeyword( self ):
        return '</table>'

    def interpreteDocument( self, document ):
        import re, sys
        elem_game = document.get_element_at_path( "/html/tr" )
        while elem_game != None:
            try:
                teams = None
                score = None
                state = None
                elem_game = elem_game.next_sibling( 'tr' )
                for child in elem_game.get_children():
                    if isinstance( child, Element ) == False:continue
                    if teams == None:
                        items = child.get_text( '<>' ).split( '<>' )
                        if len( items ) >= 3:
                            teams = ( items[ 0 ], items[ 2 ] )
                        continue
                    items = child.get_children()
                    if score == None and teams != None and len( items ) >= 2:
                        score = ( items[ 0 ].get_text(), items[ 1 ].get_text() )
                        continue
                    text = child.get_text( ',' ).split( ',' )[ 0 ]
                    if teams != None and score != None and state == None and len( text ) > 0:
                        state = text
                        break
                    pass
                if teams != None and score != None:
                    self.games.append( ( teams[ 0 ], teams[ 1 ], score[ 0 ], score[ 1 ], state ) )
                    pass
                #print teams, score, state
                elem_game = elem_game.next_sibling( 'tr' )
            except:
                #raise
                break
                pass
            pass
        return

    def getDate( self ):
        if not self.date:
            return ""
        return self.date

    def getIcon( self, team ):
        name = ''
        team = string.lower( team )
        if re.search( 'angels', team )      : name = 'ana'
        elif re.search( 'oakland', team )   : name = 'oak'
        elif re.search( 'toronto', team )    : name = 'tor'
        elif re.search( 'tampa', team )     : name = 'tb'
        elif re.search( 'cleveland', team ) : name = 'cle'
        elif re.search( 'seattle', team )   : name = 'sea'
        elif re.search( 'baltimore', team ) : name = 'bal'
        elif re.search( 'texas', team )     : name = 'tex'
        elif re.search( 'boston', team )    : name = 'bos'
        elif re.search( 'kansas', team )    : name = 'kc'
        elif re.search( 'detroit', team )   : name = 'det'
        elif re.search( 'minnesota', team ) : name = 'min'
        elif re.search( 'white sox', team ) : name = 'cws'
        elif re.search( 'yankees', team )   : name = 'nyy'
        elif re.search( 'houston', team )   : name = 'hou'
        elif re.search( 'atlanta', team )   : name = 'atl'
        elif re.search( 'milwaukee', team ) : name = 'mil'
        elif re.search( 'louis', team )     : name = 'stl'
        elif re.search( 'cubs', team )      : name = 'chc'
        elif re.search( 'arizona', team )   : name = 'ari'
        elif re.search( 'dodgers', team )   : name = 'la'
        elif re.search( 'francisco', team ) : name = 'sf'
        elif re.search( 'florida', team )   : name = 'fla'
        elif re.search( 'mets', team )      : name = 'nym'
        elif re.search( 'washington', team ): name = 'was'
        elif re.search( 'san diego', team ) : name = 'sd'
        elif re.search( 'philadelphia', team ): name = 'phi'
        elif re.search( 'pittsburgh', team ): name = 'pit'
        elif re.search( 'cincinnati', team ): name = 'cin'
        elif re.search( 'colorado', team )  : name = 'col'

        if name != '':
            url = "http://mlb.com/mlb/images/team_logos/50x50/%s.gif" % name
            return makelogo.getURI( url, 'mlb', name = name, transparency = None )
        else:
            return ''
        pass

    def toHTML( self ):
        html = self.html_header()
        html += '<title>%s</title>' % ( self.getName() )
        html += "<body>"
        if len( self.games ) > 0:
            html += '<span class="tabletitle">%s %s</span>' % ( self.getName(), self.getDate() )
            html += "<table>"
            for game in self.games:
                lastcolumn = ""
                if len( game ) > 4:
                    lastcolumn = '<td class="status">%s</td>' % game[ 4 ]
                    pass
                icon1 = '<td class="teamlogo"><img class="logo" src="%s"/></td>' % self.getIcon( game[ 0 ] )
                icon2 = '<td class="teamlogo"><img class="logo" src="%s"/></td>' % self.getIcon( game[ 1 ] )
                team1 = '<td class="team">%s</td>' % game[ 0 ]
                team2 = '<td class="team">%s</td>' % game[ 1 ] 
                html += '<tr>%s%s<td class="score">%s - %s</td>%s%s%s</tr>\n' % ( icon1, team1, game[ 2 ], game[ 3 ], team2, icon2, lastcolumn )
                pass
            html += "</table>"
        else:
            html += "<div id=\"error\">Retrieving failure</div>"
            pass
        html += "</body>"
        html += self.html_footer()
        return html        
    pass


if __name__ == "__main__":
    from loader import *
    obj = newInstance()

    if obj != None and obj.isAvailable():
        url = obj.getURL()
        #data = loadHTML( url )
        
        data = loadHTML_test( "../../html/mlb_yahoo_com4.html" )
        kw_start = obj.getStartKeyword()
        kw_end   = obj.getEndKeyword()
        parser = DOMConverter()
        if kw_start == None or kw_end == None:
            parser.feed( obj.decode( data ) )
            pass
        else:
            flag_inside = False
            parser.feed( '<html>' )
            for line in re.split( "\n", data ):
                line = obj.decode( line.strip() )
                if flag_inside:
                    if line.count( kw_end ) > 0: flag_inside = False
                    else: parser.feed( line )
                elif line.count( kw_start ) > 0: flag_inside = True
                pass
            parser.feed( '</html>' )
            pass
        document = parser.get_document()
        obj.interpreteDocument( document )
        print obj.toHTML()
        pass
    pass
